<?
/*
** anti_offline_browser.php - simple php scipt against offline browsers
** Copyright (C) 2004 Stefan Bauckmeier <stefan@bauckmeier.de>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
*/
// config
$antigrabber_iplistdir		= '/path/to/iplists';		// path to directory with the searchengine-ip-lists
$antigrabber_errorurl		= '/anti_offline_browser.html';	// url for redirection on detecting offline browser
$antigrabber_max_site_rate	= 6;				// max pages per 10 seconds
// config end

// basic detection using user agent strings
if ( 
	eregi('Offline Explorer', $_SERVER['HTTP_USER_AGENT']) ||
	eregi('HTTrack', $_SERVER['HTTP_USER_AGENT']) ||
	$_SESSION['antigrabber_userisgrabber'] == true
) {
	header('Location: '.$antigrabber_errorurl);
	die("go to <a href=\"$antigrabber_errorurl\">$antigrabber_errorurl</a> and read why u are banned");
}


// detect offline explorer calculating page hits per 10seconds

// count hits of this user
$_SESSION['antigrabber_count']++;

// store time when the user entered the page
if ( !isset($_SESSION['antigrabber_starttime']) ) {
	$_SESSION['antigrabber_starttime'] = time();
}

if ( $_SESSION['antigrabber_issearchengine'] != true ) {
	if ( $_SESSION['antigrabber_count'] > 1 && (time() - $_SESSION['antigrabber_starttime']) > 1 ) {
		
		$antigrabber_time = @round((time() - $_SESSION['antigrabber_starttime']) / 10);
		
		if ( ($_SESSION['antigrabber_count'] / $antigrabber_time) > $antigrabber_max_site_rate ) {

			// check if ip is in searchengine-ip-list
			$antigrabber_ipdir = dir($antigrabber_iplistdir);
			while (false !== ($antigrabber_ipdirentry = $antigrabber_ipdir->read()) && $_SESSION['antigrabber_issearchengine'] != true) {
				if ( is_file($iplistdir.'/'.$antigrabber_ipdirentry) && substr($antigrabber_ipdirentry,0,1) != '.' ) {
					$antigrabber_ipfile = @fopen($iplistdir.'/'.$antigrabber_ipdirentry, 'r');
					if($antigrabber_ipfile) {
						while(!feof($antigrabber_ipfile) && $_SESSION['antigrabber_issearchengine'] != true) {
							$antigrabber_ipfileline = trim(fgets($antigrabber_ipfile));
							if ( strlen($antigrabber_ipfileline) > 1 && substr($antigrabber_ipfileline,0,1) != '#' ) {
								if ( $_SERVER['REMOTE_ADDR'] == $antigrabber_ipfileline ) {
									$_SESSION['antigrabber_issearchengine'] = true;
								}
							}
						}
						fclose($antigrabber_ipfile);
					}
				}
			}
			
			if ( $_SESSION['antigrabber_issearchengine'] != true ) {
				$_SESSION['antigrabber_userisgrabber'] = true;
				header('Location: '.$antigrabber_errorurl);
				die("go to <a href=\"$antigrabber_errorurl\">$antigrabber_errorurl</a> and read why u are banned");
			}
		}
	}
}
?>